type Query {
  gridConfigs: [GridConfig!]!
  gridConfig(gridConfigId: String!): GridConfig!
  game(gameId: String!, playerId: String!): Game!
  currentGame: Game
}

type Mutation {
  createGrid(gridConfigId: String!): Grid!
  startGame(grid: GridInput!): Game!
  dropBomb(gameId: String!, playerId: String!, coordinate: CoordinateInput!): Game!
  endGame(gameId: String!, playerId: String!): Boolean!
}

type GridSize {
  x: Int!
  y: Int!
}

input GridSizeInput {
  x: Int!
  y: Int!
}

type Coordinate {
  x: Int!
  y: Int!
}

input CoordinateInput {
  x: Int!
  y: Int!
}

type Ship {
  name: String!
  length: Int!
  coordinates: [Coordinate!]!
}

input ShipInput {
  name: String!
  length: Int!
  coordinates: [CoordinateInput!]!
}

type BombedCoordinate {
  x: Int!
  y: Int!
  hit: Boolean!
  sunkenShip: Ship
}

type GridConfig {
  id: String!
  name: String!
  size: GridSize!
  ships: [Ship!]!
}

type Grid {
  gridConfigId: String!
  size: GridSize!
  ships: [Ship!]!
  playerId: String!
  playerNum: Int!
  systemPlayer: Boolean!
  bombedCoordinates: [BombedCoordinate!]!
}

input GridInput {
  gridConfigId: String!
  size: GridSizeInput!
  ships: [ShipInput!]!
}

type Game {
  id: String!
  yourGrid: Grid!
  opponentGrid: Grid!
  winningPlayerNum: Int
}
